clear ;
warning off; %#ok<WNOFF>

%% Specification of controls
for Inspec=[1 2 3 4]
    spec =Inspec;
    disp(spec);

    %% Import data
    data = dlmread('restatw.dat','\t',1,0);
    wgt = data(:,1);
    ira	= data(:,2);
    a401 = data(:,3);
    hval = data(:,4);
    hmort = data(:,5);
    hequity	= data(:,6);
    nifa = data(:,7);
    net_nifa = data(:,8);
    tfa = data(:,9);
    net_tfa	= data(:,10);
    tfa_he = data(:,11);
    tw = data(:,12);
    age = data(:,13);
    inc = data(:,14);
    fsize = data(:,15);
    educ = data(:,16);
    db = data(:,17);
    marr = data(:,18);
    male = data(:,19);
    twoearn = data(:,20);
    dum91 = data(:,21);
    e401 = data(:,22);
%     i1 = data(:,23);
    i2 = data(:,24);
    i3 = data(:,25);
    i4 = data(:,26);
    i5 = data(:,27);
    i6 = data(:,28);
    i7 = data(:,29);
    p401 = data(:,30);
    pira = data(:,31);
    hown = data(:,32);
    a1 = data(:,33);
    a2 = data(:,34);
    a3 = data(:,35);
    a4 = data(:,36);
    a5 = data(:,37);
    nohs = data(:,38);
    hs = data(:,39);
    smcol = data(:,40);
    col = data(:,41);
    a = data(:,42);
    icat = data(:,43);
    ecat = data(:,44);
    f1 = data(:,45);
    f2 = data(:,46);
    f3 = data(:,47);
    f4 = data(:,48);
    f5 = data(:,49);
    f6 = data(:,50);
    f = data(:,51);
    zhat = data(:,52);
    wntfa1 = data(:,53);
    wntfa2 = data(:,54);
    wntfa3 = data(:,55);
    wntfa4 = data(:,56);
    wntfa5 = data(:,57);
    wntfa6 = data(:,58);
    wntfa7 = data(:,59);
    wnet_nifa1 = data(:,60);
    wnet_nifa2 = data(:,61);
    wnet_nifa3 = data(:,62);
    wnet_nifa4 = data(:,63);
    wnet_nifa5 = data(:,64);
    wnet_nifa6 = data(:,65);
    wnet_nifa7 = data(:,66);
    wtw1 = data(:,67);
    wtw2 = data(:,68);
    wtw3 = data(:,69);
    wtw4 = data(:,70);
    wtw5 = data(:,71);
    wtw6 = data(:,72);
    wtw7 = data(:,73);
    net_n401 = data(:,74);
    wnet_n4014 = data(:,75);
    i1 = icat == 1;
    
    clear data;
    
    %% Define main variables
    y = net_tfa ;
    d = e401 ;
    z = e401 ;
    n = size(y,1);

    %% Define controls
    % Note that intercept NOT included in x

    if spec == 1  % Benjamin, CH baseline
        x = [i2,i3,i4,i5,i6,i7,a2,a3,a4,a5,fsize,hs,smcol,col,marr,twoearn,db,pira,hown];
        names = {'i2','i3','i4','i5','i6','i7','a2','a3','a4','a5','fsize','hs','smcol','col','marr','twoearn','db','pira','hown'}';
        keep = (std(x) > 1e-5) & (std(x(z==1,:)) > 1e-5) & (std(x(z==0,:)) > 1e-5);
        x = x(:,keep);
        names = names(keep);
        xS = x;
        [~,keepA] = noncollinear_Revision(xS);
        [~,keep1] = noncollinear_Revision(xS(z == 1,:));
        [~,keep0] = noncollinear_Revision(xS(z == 0,:));
        
    elseif spec == 2  % Nonlinearity - piecewise quadratic
        age = (age-25)/(64-25);
        inc = (inc+2652)/(242124+2652);
        fsize = fsize/13;
        educ = educ/18;
        idum = [i1,i2,i3,i4,i5,i6,i7];
        adum = [a1,a2,a3,a4,a5];
        edum = [nohs hs smcol col];
        odum = [marr twoearn db pira hown];
        onames = {'marr','twoearn','db','pira','hown'}';
        iS = [idum inc (inc*ones(1,7)).*idum inc.^2 ((inc.^2)*ones(1,7)).*idum];
        inames = {'i1','i2','i3','i4','i5','i6','i7','inc',...
            'inc*i1','inc*i2','inc*i3','inc*i4','inc*i5','inc*i6','inc*i7','inc^2',...
            'inc^2*i1','inc^2*i2','inc^2*i3','inc^2*i4','inc^2*i5','inc^2*i6','inc^2*i7'}';
        aS = [age age.^2 age.^3];
        anames = {'age','age^2','age^3'}';
        eS = [educ educ.^2];
        enames = {'educ','educ^2'}';
        fS = [fsize fsize.^2];
        fnames = {'fsize','fsize^2'}';
        x = [iS aS eS fS odum];
        names = [inames ; anames ; enames ; fnames ; onames];
        keep = (std(x) > 1e-5) & (std(x(z==1,:)) > 1e-5) & (std(x(z==0,:)) > 1e-5);
        x = x(:,keep);
        names = names(keep);
        xS = x;
        [~,keepA] = noncollinear_Revision(xS);
        [~,keep1] = noncollinear_Revision(xS(z == 1,:));
        [~,keep0] = noncollinear_Revision(xS(z == 0,:));
        
    elseif spec == 3  % Income interactions
        age = (age-25)/(64-25);
        inc = (inc+2652)/(242124+2652);
        fsize = fsize/13;
        educ = educ/18;
        idum = [i1,i2,i3,i4,i5,i6,i7];
        adum = [a1,a2,a3,a4,a5];
        edum = [nohs hs smcol col];
        odum = [marr twoearn db pira hown];
        onames = {'marr','twoearn','db','pira','hown'}';
        iS = [idum inc (inc*ones(1,7)).*idum inc.^2 ((inc.^2)*ones(1,7)).*idum];
        inames = {'i1','i2','i3','i4','i5','i6','i7','inc',...
            'inc*i1','inc*i2','inc*i3','inc*i4','inc*i5','inc*i6','inc*i7','inc^2',...
            'inc^2*i1','inc^2*i2','inc^2*i3','inc^2*i4','inc^2*i5','inc^2*i6','inc^2*i7'}';
        aS = [age age.^2 age.^3];
        anames = {'age','age^2','age^3'}';
        eS = [educ educ.^2];
        enames = {'educ','educ^2'}';
        fS = [fsize fsize.^2];
        fnames = {'fsize','fsize^2'}';
        xMain = [iS aS eS fS odum];
        namesMain = [inames ; anames ; enames ; fnames ; onames];
        xO = [aS eS fS odum];
        namesO = [anames ; enames ; fnames ; onames];
        nI = size(iS,2);
        nO = size(xO,2);
        xInt = zeros(n,nI*nO);
        namesInt = cell(nI*nO,1);
        for ii = 1:nI
            for jj = 1:nO
                xInt(:,nO*(ii-1)+jj) = iS(:,ii).*xO(:,jj);
                namesInt(nO*(ii-1)+jj,1) = strcat(inames(ii),'X',namesO(jj));
            end
        end
        x = [xMain xInt];
        names = [namesMain ; namesInt];
        keep = (std(x) > 1e-5) & (std(x(z==1,:)) > 1e-5) & (std(x(z==0,:)) > 1e-5);
        x = x(:,keep);
        names = names(keep);
        xS = x;
        [~,keepA] = noncollinear_Revision(xS);
        [~,keep1] = noncollinear_Revision(xS(z == 1,:));
        [~,keep0] = noncollinear_Revision(xS(z == 0,:));
        
    elseif spec == 4
        age = (age-25)/(64-25);
        inc = (inc+2652)/(242124+2652);
        fsize = fsize/13;
        educ = educ/18;
        idum = [i1,i2,i3,i4,i5,i6,i7];
        adum = [a1,a2,a3,a4,a5];
        edum = [nohs hs smcol col];
        odum = [marr twoearn db pira hown];
        onames = {'marr','twoearn','db','pira','hown'}';
        iS = [idum inc (inc*ones(1,7)).*idum inc.^2 ((inc.^2)*ones(1,7)).*idum];
        inames = {'i1','i2','i3','i4','i5','i6','i7','inc',...
            'inc*i1','inc*i2','inc*i3','inc*i4','inc*i5','inc*i6','inc*i7','inc^2',...
            'inc^2*i1','inc^2*i2','inc^2*i3','inc^2*i4','inc^2*i5','inc^2*i6','inc^2*i7'}';
        aS = [age age.^2 age.^3];
        anames = {'age','age^2','age^3'}';
        eS = [educ educ.^2];
        enames = {'educ','educ^2'}';
        fS = [fsize fsize.^2];
        fnames = {'fsize','fsize^2'}';
        xMain = [iS aS eS fS odum];
        namesMain = [inames ; anames ; enames ; fnames ; onames];

        % Interactions among auxiliary variables
        xO = [aS eS fS odum];
        namesO = [anames ; enames ; fnames ; onames];
        nxO = size(xO,2);
        
        % hown interactions
        xHown = xO(:,1:end-1).*(hown*ones(1,nxO-1));
        namesHown = namesO(1:end-1,:);
        for ii = 1:nxO-1
            namesHown{ii} = strcat(namesHown{ii},'Xhown');
        end
        
        % pira interactions
        xPira = xO(:,1:end-2).*(pira*ones(1,nxO-2));
        namesPira = namesO(1:end-2,:);
        for ii = 1:nxO-2
            namesPira{ii} = strcat(namesPira{ii},'Xpira');
        end
        
        % db interactions
        xDb = xO(:,1:end-3).*(db*ones(1,nxO-3));
        namesDb = namesO(1:end-3,:);
        for ii = 1:nxO-3
            namesDb{ii} = strcat(namesDb{ii},'Xdb');
        end
        
        % twoearn interactions
        xTwoearn = xO(:,1:end-4).*(twoearn*ones(1,nxO-4));
        namesTwoearn = namesO(1:end-4,:);
        for ii = 1:nxO-4
            namesTwoearn{ii} = strcat(namesTwoearn{ii},'Xtwoearn');
        end
        
        % marr interactions
        xMarr = xO(:,1:end-5).*(marr*ones(1,nxO-5));
        namesMarr = namesO(1:end-5,:);
        for ii = 1:nxO-5
            namesMarr{ii} = strcat(namesMarr{ii},'Xmarr');
        end
        
        % educ interactions
        nEP = size(eS,2);
        nAP = size(aS,2);
        nFP = size(fS,2);
        xEd = zeros(n,(nAP+nFP)*nEP);
        namesEd = cell((nAP+nFP)*nEP,1);
        xTemp = [aS fS];
        namesTemp = [anames;fnames];
        for ii = 1:nEP
            for jj = 1:nAP+nFP
                xEd(:,(nAP+nFP)*(ii-1)+jj) = eS(:,ii).*xTemp(:,jj);
                namesEd((nAP+nFP)*(ii-1)+jj,1) = strcat(enames(ii),'X',namesTemp(jj));
            end
        end
        
        % fsize interactions
        xFs = zeros(n,(nAP)*nFP);
        namesFs = cell((nAP)*nFP,1);
        xTemp = aS;
        namesTemp = anames;
        for ii = 1:nFP
            for jj = 1:nAP
                xFs(:,(nAP)*(ii-1)+jj) = fS(:,ii).*xTemp(:,jj);
                namesFs((nAP)*(ii-1)+jj,1) = strcat(fnames(ii),'X',namesTemp(jj));
            end
        end

        % Income interactions
        xO = [aS eS fS odum xHown xPira xDb xTwoearn xMarr xEd xFs];
        namesO = [anames ; enames ; fnames ; onames ; namesHown ; ...
            namesPira ; namesDb ; namesTwoearn ; namesMarr ; ...
            namesEd ; namesFs ];
        nI = size(iS,2);
        nO = size(xO,2);
        xInt = zeros(n,nI*nO);
        namesInt = cell(nI*nO,1);
        for ii = 1:nI
            for jj = 1:nO
                xInt(:,nO*(ii-1)+jj) = iS(:,ii).*xO(:,jj);
                namesInt(nO*(ii-1)+jj,1) = strcat(inames(ii),'X',namesO(jj));
            end
        end
        x = [xMain xHown xPira xDb xTwoearn xMarr xEd xFs xInt];
        names = [namesMain ; namesHown ; ...
            namesPira ; namesDb ; namesTwoearn ; namesMarr ; ...
            namesEd ; namesFs ; namesInt];
        keep = (std(x) > 1e-5) & (std(x(z==1,:)) > 1e-5) & (std(x(z==0,:)) > 1e-5);
        x = x(:,keep);
        names = names(keep);
        xS = x;
        [~,keepA] = noncollinear_Revision(xS);
        [~,keep1] = noncollinear_Revision(xS(z == 1,:));
        [~,keep0] = noncollinear_Revision(xS(z == 0,:));

    end
    pA = size(x,2);
    p = size(xS(:,keepA),2);
    
    %% Linear Model - No Selection
    Pd = d - [xS(:,keepA) ones(n,1)]*([xS(:,keepA) ones(n,1)]\d);
    Py = y - [xS(:,keepA) ones(n,1)]*([xS(:,keepA) ones(n,1)]\y);
    bols = Pd\Py;
    e = Py - Pd*bols;
    sols = sqrt((n-1)/(n-p-1))*hetero_se(Pd,e,1/(Pd'*Pd));
    
    %% Linear Model - Selection
    lambdaL = 2.2*sqrt(n)*norminv(1-(.1/log(n))/(2*p));
    Indx1= feasiblePostLassoMatTool(y,x,'lambda',lambdaL);
    Pindx1=abs(Indx1)>0;
    Indx2=feasiblePostLassoMatTool(z,x,'lambda',lambdaL);
    Pindx2=abs(Indx2)>0;
    IndX = max([Pindx1,Pindx2],[],2);
    xSel = x(:,IndX);
    SX=[z xSel ones(n,1)];
    SBeta=(SX'*SX)\(SX'*y);
    e = y - SX*SBeta;
    sols_sel = hetero_se(SX,e,inv(SX'*SX));
    
    %% LATE and LATT - No Selection
    % E[Z|X] = mz_x
    NSb_z_xPL = glmfit(xS(:,keepA),z,'binomial','link','logit');
    NSmz_x = glmval(NSb_z_xPL,xS(:,keepA),'logit');
    NSmz_x = NSmz_x.*(NSmz_x > 1e-12 & NSmz_x < 1-1e-12) + (1-1e-12)*(NSmz_x > 1-1e-12) + 1e-12*(NSmz_x < 1e-12);
    
    nT = sum(NSmz_x <= 1e-12 | NSmz_x >= 1-1e-12);
    disp(nT);
    
    if nT < n
        % E[Y|Z = 1,X] = my_z1x
        NSb_y_z1xPL = [xS(z == 1,keep1) ones(sum(z == 1),1)]\y(z == 1,1);
        NSmy_z1x = [xS(:,keep1) ones(n,1)]*NSb_y_z1xPL;
        
        % E[Y|Z = 0,X] = my_z0x
        NSb_y_z0xPL = [xS(z == 0,keep0) ones(sum(z == 0),1)]\y(z == 0,1);
        NSmy_z0x = [xS(:,keep0) ones(n,1)]*NSb_y_z0xPL;
        
        % E[D|Z = 1,X] = md_z1x
        %     NSb_d_z1xPL = glmfit(xS(z == 1,:),d(z == 1,1),'binomial','link','logit');
        %     NSmd_z1x = glmval(NSb_d_z1xPL,xS,'logit');
        NSmd_z1x = ones(n,1);
        
        % E[D|Z = 0,X] = md_z0x
        NSmd_z0x = zeros(n,1);
        
        % late
        LATE = late(y,d,z,NSmy_z1x,NSmy_z0x,NSmz_x,NSmd_z1x,NSmd_z0x,1);
        
        % latt
        LATT = latt(y,d,z,NSmy_z0x,NSmz_x,NSmd_z0x,1);
    end
    
    %% LATE and LATT - Selection
    lambda = 2.2*sqrt(n)*norminv(1-(.1/log(n))/(2*(2*p)));
    
    % E[Y|Z = 1,X] = my_z1x
    b_y_z1xL = feasiblePostLassoMatTool(y(z == 1,1),x(z == 1,:),'lambda',lambda);
    use_y_z1x = abs(b_y_z1xL) > 0;
    b_y_z1xPL = [x(z == 1,use_y_z1x) ones(sum(z == 1),1)]\y(z == 1,1);
    my_z1x = [x(:,use_y_z1x) ones(n,1)]*b_y_z1xPL;
    
    % E[Y|Z = 0,X] = my_z0x
    b_y_z0xL = feasiblePostLassoMatTool(y(z == 0,1),x(z == 0,:),'lambda',lambda);
    use_y_z0x = abs(b_y_z0xL) > 0;
    b_y_z0xPL = [x(z == 0,use_y_z0x) ones(sum(z == 0),1)]\y(z == 0,1);
    my_z0x = [x(:,use_y_z0x) ones(n,1)]*b_y_z0xPL;
    
    % E[D|Z = 1,X] = md_z1x
    % b_d_z1xL = feasiblePostLassoMatTool(d(z == 1,1),x(z == 1,:),'Dist','binomial','linkFun','logit','lambda',lambda);
    % use_d_z1x = abs(b_d_z1xL) > 0;
    % b_d_z1xPL = glmfit(x(z == 1,use_d_z1x),d(z == 1,1),'binomial','link','logit');
    % md_z1x = glmval(b_d_z1xPL,x(:,use_d_z1x),'logit');
    md_z1x = ones(n,1);
    
    % E[D|Z = 0,X] = md_z0x
    md_z0x = zeros(n,1);
    
    % E[Z|X] = mz_x
    lambdaP = 2.2*sqrt(n)*norminv(1-(.1/log(n))/(2*p));
    b_z_xL = feasiblePostLassoMatTool(z,x,'Dist','binomial','linkFun','logit','lambda',lambdaP);
    use_z_x = abs(b_z_xL) > 0;
    b_z_xPL = glmfit(x(:,use_z_x),z,'binomial','link','logit');
    mz_x = glmval(b_z_xPL,x(:,use_z_x),'logit');
    mz_x = mz_x.*(mz_x > 1e-12 & mz_x < 1-1e-12) + (1-1e-12)*(mz_x > 1-1e-12) + 1e-12*(mz_x < 1e-12);
    
    % late
    LATE_SEL = late(y,d,z,my_z1x,my_z0x,mz_x,md_z1x,md_z0x,1);
    
    % latt
    LATT_SEL = latt(y,d,z,my_z0x,mz_x,md_z0x,1);
    
    
    %% LQTE and LQTT - Data
    
    % Create matrix with columns of form 1(y < u) for u approximately covering
    % the support of y
    
    tausAll = 5:95;
    
    pt = prctile(y,tausAll);
    [percs,Itaus,Ipercs] = unique(pt);
    taus = tausAll(Itaus)/100;
    
    calU = (taus >= .1) & (taus <= .9);  % Will look at QTE over this interval
    yF = y*ones(1,numel(taus)) <= ones(n,1)*percs;
    
    %% LQTE and LQTT - No Selection
    if nT < n
        % Note that E[YD|Z = 0,X] = 0
        % Note that E[D|Z = 1,X], E[D|Z = 0,X], and E[Z|X] are as above.
        
        NSmyd1_z1x = zeros(size(yF));
        NSmyd0_z1x = zeros(size(yF));
        NSmyd1_z0x = zeros(size(yF));
        NSmyd0_z0x = zeros(size(yF));
        for ii = 1:size(yF,2)
            if floor(ii/10) == ii/10
                disp(ii);
            end
            % E[YD|Z = 1,X]
            NSb_yd1_z1xPL = glmfit(xS(z == 1,keep1),yF(z == 1,ii).*d(z == 1,1),'binomial','link','logit');
            NSmyd1_z1x(:,ii) = glmval(NSb_yd1_z1xPL,xS(:,keep1),'logit');
            % E[Y(1-D)|Z = 1,X]
            %         NSb_yd0_z1xPL = glmfit(xS(z == 1,:),yF(z == 1,ii).*(1-d(z == 1,1)),'binomial','link','logit');
            %         NSmyd0_z1x(:,ii) = glmval(NSb_yd0_z1xPL,xS,'logit');
            NSmyd0_z1x(:,ii) = zeros(n,1);
            % E[YD|Z = 0,X]
            NSmyd1_z0x(:,ii) = zeros(n,1);
            % E[Y(1-D)|Z = 1,X]
            NSb_yd0_z0xPL = glmfit(xS(z == 0,keep0),yF(z == 0,ii).*(1-d(z == 0,1)),'binomial','link','logit');
            NSmyd0_z0x(:,ii) = glmval(NSb_yd0_z0xPL,xS(:,keep0),'logit');
        end
        
        [NSlqte,NStalpha_lqte,NSlqtt,NStalpha_lqtt] = ...
            lqteAndlqtt(yF,d,z,taus,percs,NSmyd1_z1x,NSmyd0_z1x,NSmyd1_z0x,NSmyd0_z0x,NSmz_x,NSmd_z1x,NSmd_z0x,1);
        
        %     % Plot QTE results
        %     figure; plot(taus(calU),NSlqte(1,calU),'k',...
        %         taus(calU),NSlqte(1,calU)-NStalpha_lqte*NSlqte(2,calU),'k--',...
        %         taus(calU),NSlqte(1,calU)+NStalpha_lqte*NSlqte(2,calU),'k--');
        %
        %     figure; plot(taus(calU),NSlqtt(1,calU),'k',...
        %         taus(calU),NSlqtt(1,calU)-NStalpha_lqtt*NSlqtt(2,calU),'k--',...
        %         taus(calU),NSlqtt(1,calU)+NStalpha_lqtt*NSlqtt(2,calU),'k--');
    end
    
    %% LQTE and LQTT - Selection
    
    % Need to do LOTS of selection.  Need myd1_z1x = E[YD | Z = 1, X],
    % myd0_z1x = E[Y(1-D) | Z = 1, X], myd1_z0x = E[YD | Z = 0, X],
    % myd0_z0x = E[Y(1-D) | Z = 0, X] for every column in yF
    
    % Note that E[YD|Z = 0,X] = 0
    
    % Note that E[D|Z = 1,X], E[D|Z = 0,X], and E[Z|X] are as above, but
    % adjusting penalty level to account for functional data.
    lambdaU = 2.2*sqrt(n)*norminv(1-(.1/log(n))/(2*(2*p)*n));
    
    % E[D|Z = 1,X] = md_z1x
    % b_d_z1xLU = feasiblePostLassoMatTool(d(z == 1,1),x(z == 1,:),'Dist','binomial','linkFun','logit','lambda',lambdaU);
    % use_d_z1xU = abs(b_d_z1xLU) > 0;
    % b_d_z1xPL_U = glmfit(x(z == 1,use_d_z1xU),d(z == 1,1),'binomial','link','logit');
    % md_z1xU = glmval(b_d_z1xPL_U,x(:,use_d_z1xU),'logit');
    md_z1xU = ones(n,1);
    
    % E[D|Z = 0,X] = md_z0x
    md_z0xU = zeros(n,1);
    
    % E[Z|X] = mz_x
    lambdaUP = 2.2*sqrt(n)*norminv(1-(.1/log(n))/(2*p*n));
    b_z_xLU = feasiblePostLassoMatTool(z,x,'Dist','binomial','linkFun','logit','lambda',lambdaUP);
    use_z_xU = abs(b_z_xLU) > 0;
    b_z_xPL_U = glmfit(x(:,use_z_xU),z,'binomial','link','logit');
    mz_xU = glmval(b_z_xPL_U,x(:,use_z_xU),'logit');
    mz_xU = mz_xU.*(mz_xU > 1e-12 & mz_xU < 1-1e-12) + (1-1e-12)*(mz_xU > 1-1e-12) + 1e-12*(mz_xU < 1e-12);
    
    % Variable selection using feasible Lasso
    b_yd1_z1xL = zeros(size(x,2),size(yF,2));
    b_yd0_z1xL = zeros(size(x,2),size(yF,2));
    b_yd0_z0xL = zeros(size(x,2),size(yF,2));
    use_yd1_z1x = false(size(x,2),size(yF,2));
    use_yd0_z1x = false(size(x,2),size(yF,2));
    use_yd0_z0x = false(size(x,2),size(yF,2));
    myd1_z1xU = zeros(size(yF));
    myd0_z1xU = zeros(size(yF));
    myd1_z0xU = zeros(size(yF));
    myd0_z0xU = zeros(size(yF));
    for ii = 1:size(yF,2)
        if floor(ii/10) == ii/10
            disp(ii);
        end
        % Selection for E[YD|Z=1,X]
        b_yd1_z1xL(:,ii) = feasiblePostLassoMatTool(yF(z == 1,ii).*d(z == 1,1),x(z == 1,:),...
            'Dist','binomial','linkFun','logit','lambda',lambdaU);
        use_yd1_z1x(:,ii) = abs(b_yd1_z1xL(:,ii)) > 0;
        b_yd1_z1xPL = glmfit(x(z == 1,use_yd1_z1x(:,ii)),yF(z == 1,ii).*d(z == 1,1),'binomial','link','logit');
        myd1_z1xU(:,ii) = glmval(b_yd1_z1xPL,x(:,use_yd1_z1x(:,ii)),'logit');
        % Selection for E[Y(1-D)|Z=1,X]
        %     b_yd0_z1xL(:,ii) = feasiblePostLassoMatTool(yF(z == 1,ii).*(1-d(z == 1,1)),x(z == 1,:),...
        %         'Dist','binomial','linkFun','logit','lambda',lambdaU);
        %     use_yd0_z1x(:,ii) = abs(b_yd0_z1xL(:,ii)) > 0;
        %     b_yd0_z1xPL = glmfit(x(z == 1,use_yd0_z1x(:,ii)),yF(z == 1,ii).*(1-d(z == 1,1)),'binomial','link','logit');
        %     myd0_z1xU(:,ii) = glmval(b_yd0_z1xPL,x(:,use_yd0_z1x(:,ii)),'logit');
        myd0_z1xU(:,ii) = zeros(n,1);
        % Selection for E[YD|Z=0,X]
        myd1_z0xU(:,ii) = zeros(n,1);
        % Selection for E[Y(1-D)|Z=0,X]
        b_yd0_z0xL(:,ii) = feasiblePostLassoMatTool(yF(z == 0,ii).*(1-d(z == 0,1)),x(z == 0,:),...
            'Dist','binomial','linkFun','logit','lambda',lambdaU);
        use_yd0_z0x(:,ii) = abs(b_yd0_z0xL(:,ii)) > 0;
        b_yd0_z0xPL = glmfit(x(z == 0,use_yd0_z0x(:,ii)),yF(z == 0,ii).*(1-d(z == 0,1)),'binomial','link','logit');
        myd0_z0xU(:,ii) = glmval(b_yd0_z0xPL,x(:,use_yd0_z0x(:,ii)),'logit');
    end
    
    [lqte,talpha_lqte,lqtt,talpha_lqtt] = ...
        lqteAndlqtt(yF,d,z,taus,percs,myd1_z1xU,myd0_z1xU,myd1_z0xU,myd0_z0xU,mz_xU,md_z1xU,md_z0xU,1);
    
    % % Plot QTE results
    % figure; plot(taus(calU),lqte(1,calU),'k',...
    %     taus(calU),lqte(1,calU)-talpha_lqte*lqte(2,calU),'k--',...
    %     taus(calU),lqte(1,calU)+talpha_lqte*lqte(2,calU),'k--');
    %
    % figure; plot(taus(calU),lqtt(1,calU),'k',...
    %     taus(calU),lqtt(1,calU)-talpha_lqtt*lqtt(2,calU),'k--',...
    %     taus(calU),lqtt(1,calU)+talpha_lqtt*lqtt(2,calU),'k--');
    
    
    %% Save results
    savefile = strcat('LATEPaperNetTFAExampleExogenousSpecificationFinal',num2str(spec));
    save(savefile) ;
end
