%% Indicators specification - QTE

clear ;

load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

figure;
subplot(3,2,1), plot(taus(calU),NSlqte(1,calU),'b');

hold on;
plot(taus(calU),lqte(1,calU),'r','LineWidth',2);
title({'Net Total Financial Assets','QTE'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('No Selection','Selection','Location','NorthWest');

plot(taus(calU),NSlqte(1,calU)-NStalpha_lqte*NSlqte(2,calU),'b--',...
        taus(calU),NSlqte(1,calU)+NStalpha_lqte*NSlqte(2,calU),'b--');
plot(taus(calU),lqte(1,calU)-talpha_lqte*lqte(2,calU),'r--',...
        taus(calU),lqte(1,calU)+talpha_lqte*lqte(2,calU),'r--','LineWidth',2);

hold off;


clear ;

load LATEPaperTotalWealthExampleExogenousSpecificationFinal3 ;

subplot(3,2,3), plot(taus(calU),NSlqte(1,calU),'b');

hold on;
plot(taus(calU),lqte(1,calU),'r','LineWidth',2);
title({'Total Wealth','QTE'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('No Selection','Selection','Location','NorthWest');

plot(taus(calU),NSlqte(1,calU)-NStalpha_lqte*NSlqte(2,calU),'b--',...
        taus(calU),NSlqte(1,calU)+NStalpha_lqte*NSlqte(2,calU),'b--');
plot(taus(calU),lqte(1,calU)-talpha_lqte*lqte(2,calU),'r--',...
        taus(calU),lqte(1,calU)+talpha_lqte*lqte(2,calU),'r--','LineWidth',2);

hold off;

clear ;
load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

subplot(3,2,5), plot(taus(calU),lqte(1,calU),'b','LineWidth',2);
hold on;

clear ;
load LATEPaperTotalWealthExampleExogenousSpecificationFinal3 ;
plot(taus(calU),lqte(1,calU),'r','LineWidth',2);
title({'Net Total Financial Assests vs. Total Wealth','QTE, Selection'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('Net TFA','Tot. Wealth','Location','NorthWest');

plot(taus(calU),lqte(1,calU)-talpha_lqte*lqte(2,calU),'r--',...
        taus(calU),lqte(1,calU)+talpha_lqte*lqte(2,calU),'r--','LineWidth',2);
    
clear ;

load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

plot(taus(calU),lqte(1,calU)-talpha_lqte*lqte(2,calU),'b--',...
        taus(calU),lqte(1,calU)+talpha_lqte*lqte(2,calU),'b--','LineWidth',2);
    
clear ;    


%% Indicators specification - QTT

clear ;

load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

subplot(3,2,2), plot(taus(calU),NSlqtt(1,calU),'b');

hold on;
plot(taus(calU),lqtt(1,calU),'r','LineWidth',2);
title({'Net Total Financial Assets','QTT'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('No Selection','Selection','Location','NorthWest');

plot(taus(calU),NSlqtt(1,calU)-NStalpha_lqtt*NSlqtt(2,calU),'b--',...
        taus(calU),NSlqtt(1,calU)+NStalpha_lqtt*NSlqtt(2,calU),'b--');
plot(taus(calU),lqtt(1,calU)-talpha_lqtt*lqtt(2,calU),'r--',...
        taus(calU),lqtt(1,calU)+talpha_lqtt*lqtt(2,calU),'r--','LineWidth',2);

hold off;


clear ;

load LATEPaperTotalWealthExampleExogenousSpecificationFinal3 ;

subplot(3,2,4), plot(taus(calU),NSlqtt(1,calU),'b');

hold on;
plot(taus(calU),lqtt(1,calU),'r','LineWidth',2);
title({'Total Wealth','QTT'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('No Selection','Selection','Location','NorthWest');

plot(taus(calU),NSlqtt(1,calU)-NStalpha_lqtt*NSlqtt(2,calU),'b--',...
        taus(calU),NSlqtt(1,calU)+NStalpha_lqtt*NSlqtt(2,calU),'b--');
plot(taus(calU),lqtt(1,calU)-talpha_lqtt*lqtt(2,calU),'r--',...
        taus(calU),lqtt(1,calU)+talpha_lqtt*lqtt(2,calU),'r--','LineWidth',2);

hold off;

clear ;
load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

subplot(3,2,6), plot(taus(calU),lqtt(1,calU),'b','LineWidth',2);
hold on;

clear ;
load LATEPaperTotalWealthExampleExogenousSpecificationFinal3 ;
plot(taus(calU),lqtt(1,calU),'r','LineWidth',2);
title({'Net Total Financial Assests vs. Total Wealth','QTT, Selection'})   ;
xlabel('Quantile');
ylabel('Dollars (1991)');
axis([.05 .95 -10000 60000]);
set(gca,'YTick',-10000:10000:60000);
set(gca,'YTickLabel',{'-10,000','0','10,000','20,000','30,000','40,000','50,000','60,000'});
legend('Net TFA','Tot. Wealth','Location','NorthWest');

plot(taus(calU),lqtt(1,calU)-talpha_lqtt*lqtt(2,calU),'r--',...
        taus(calU),lqtt(1,calU)+talpha_lqtt*lqtt(2,calU),'r--','LineWidth',2);
    
clear ;

load LATEPaperNetTFAExampleExogenousSpecificationFinal3 ;

plot(taus(calU),lqtt(1,calU)-talpha_lqtt*lqtt(2,calU),'b--',...
        taus(calU),lqtt(1,calU)+talpha_lqtt*lqtt(2,calU),'b--','LineWidth',2);
    
clear ;    



