function [out,eff_if] = lasf(y,d,z,myd1_z1x,myd1_z0x,myd0_z1x,myd0_z0x,mz_x,md_z1x,md_z0x,d0,w,bootstrap,reps,scheme)
% my_dx = E[Y | D, X];
% md_x = E[D | X];
% mz_x = E[Z | X];
% md_zx = E[D | Z, X];
% my_zx = E[Y | Z, X];
% md = E[D];
% mz = E[Z];
% myd1_zx = E[YD | Z, X];
% myd0_zx = E[Y(1-D) | Z, X];

if nargin < 13
    bootstrap = 0;
end
if nargin < 12
    w = ones(size(y));
end
if isempty(w)
    w = ones(size(y));
end

eff_if = w.*(d0.*(z.*(d.*y-myd1_z1x)./mz_x - ((1-z).*(d.*y-myd1_z0x)./(1-mz_x)) ...
    + myd1_z1x - myd1_z0x) ...
    + (d0-1).*(z.*((1-d).*y-myd0_z1x)./mz_x - ((1-z).*((1-d).*y-myd0_z0x)./(1-mz_x)) ...
    + myd0_z1x - myd0_z0x))/ ...
    mean(w.*(z.*(d-md_z1x)./mz_x - ((1-z).*(d-md_z0x)./(1-mz_x)) + md_z1x - md_z0x));

out = [mean(eff_if) std(eff_if)/sqrt(size(y,1))];

if bootstrap
    if nargin < 14
        reps = 500;
        scheme = 3;
    elseif nargin < 15
        scheme = 3;
    end
    
    n = size(y,1);
    bs_ests = zeros(reps,1);
    
    for ii = 1:reps
        if scheme == 1
            weights = exprnd(1,n,1)-1;
        elseif scheme == 2
            weights = randn(n,1);
        else
            weights = randn(n,1)/sqrt(2) + (randn(n,1).^2-1)/2;
        end
        weights = weights+1;
        bs_ests(ii,:) = mean(w.*(d0.*(z.*(d.*y-myd1_z1x)./mz_x - ((1-z).*(d.*y-myd1_z0x)./(1-mz_x)) ...
            + myd1_z1x - myd1_z0x) ...
            + (d0-1).*(z.*((1-d).*y-myd0_z1x)./mz_x - ((1-z).*((1-d).*y-myd0_z0x)./(1-mz_x)) ...
            + myd0_z1x - myd0_z0x)).*weights)/...
            mean(w.*(z.*(d-md_z1x)./mz_x - ((1-z).*(d-md_z0x)./(1-mz_x)) + md_z1x - md_z0x).*weights);
    end
    
    out = [out iqr(bs_ests)/(norminv(.75)-norminv(.25)) std(bs_ests)];
end


