function [lqte,talpha_lqte,lqtt,talpha_lqtt] = lqteAndlqtt(yF,d,z,taus,percs,myd1_z1x,myd0_z1x,myd1_z0x,myd0_z0x,mz_x,md_z1x,md_z0x,bootstrap,reps,scheme,alpha)
% my_dx = E[Y | D, X];
% md_x = E[D | X];
% mz_x = E[Z | X];
% md_zx = E[D | Z, X];
% my_zx = E[Y | Z, X];
% md = E[D];
% mz = E[Z];
% myd1_zx = E[YD | Z, X];
% myd0_zx = E[Y(1-D) | Z, X];

if nargin < 13
    bootstrap = 0;
end

[n,k] = size(yF);

lasf0 = zeros(size(yF,2),2);
lasf1 = zeros(size(yF,2),2);
lasft0 = zeros(size(yF,2),2);
lasft1 = zeros(size(yF,2),2);
for ii = 1:size(yF,2)
    temp1 = lasf(yF(:,ii),d,z,myd1_z1x(:,ii),myd1_z0x(:,ii),myd0_z1x(:,ii),myd0_z0x(:,ii),mz_x,md_z1x,md_z0x,0);
    lasf0(ii,:) = temp1;
    temp1 = lasf(yF(:,ii),d,z,myd1_z1x(:,ii),myd1_z0x(:,ii),myd0_z1x(:,ii),myd0_z0x(:,ii),mz_x,md_z1x,md_z0x,1);
    lasf1(ii,:) = temp1;
    temp1 = lasft(yF(:,ii),d,z,myd1_z0x(:,ii),myd0_z0x(:,ii),mz_x,md_z0x,0);
    lasft0(ii,:) = temp1;
    temp1 = lasft(yF(:,ii),d,z,myd1_z0x(:,ii),myd0_z0x(:,ii),mz_x,md_z0x,1);
    lasft1(ii,:) = temp1;
end
if sum(isnan(lasf0(:,1))) == 0
    lqsf0 = interp1(lasf0(:,1),percs,taus);
else
    lqsf0 = NaN*ones(1,numel(taus));
end
if sum(isnan(lasf1(:,1))) == 0
    lqsf1 = interp1(lasf1(:,1),percs,taus);
else
    lqsf1 = NaN*ones(1,numel(taus));
end
if sum(isnan(lasft0(:,1))) == 0
    lqsft0 = interp1(lasft0(:,1),percs,taus);
else
    lqsft0 = NaN*ones(1,numel(taus));
end
if sum(isnan(lasft1(:,1))) == 0
    lqsft1 = interp1(lasft1(:,1),percs,taus);
else
    lqsft1 = NaN*ones(1,numel(taus));
end

lqte = lqsf1 - lqsf0 ;
lqtt = lqsft1 - lqsft0 ;

if bootstrap
    if nargin < 14
        reps = 500;
        scheme = 3;
        alpha = .05;
    elseif nargin < 15
        scheme = 3;
        alpha = .05;
    elseif nargin < 16
        alpha = .05;
    end
    
    bs_lqte = zeros(reps,k);
    bs_lqtt = zeros(reps,k);

    for jj = 1:reps
        if scheme == 1
            weights = exprnd(1,n,1)-1;
        elseif scheme == 2
            weights = randn(n,1);
        else
            weights = randn(n,1)/sqrt(2) + (randn(n,1).^2-1)/2;
        end
        weights = weights+1;

        bs_lasf0 = zeros(size(yF,2),2);
        bs_lasf1 = zeros(size(yF,2),2);
        bs_lasft0 = zeros(size(yF,2),2);
        bs_lasft1 = zeros(size(yF,2),2);
        for ii = 1:size(yF,2)
            temp1 = lasf(yF(:,ii),d,z,myd1_z1x(:,ii),myd1_z0x(:,ii),myd0_z1x(:,ii),...
                myd0_z0x(:,ii),mz_x,md_z1x,md_z0x,0,weights);
            bs_lasf0(ii,:) = temp1;
            temp1 = lasf(yF(:,ii),d,z,myd1_z1x(:,ii),myd1_z0x(:,ii),myd0_z1x(:,ii),...
                myd0_z0x(:,ii),mz_x,md_z1x,md_z0x,1,weights);
            bs_lasf1(ii,:) = temp1;
            temp1 = lasft(yF(:,ii),d,z,myd1_z0x(:,ii),myd0_z0x(:,ii),mz_x,md_z0x,0,weights);
            bs_lasft0(ii,:) = temp1;
            temp1 = lasft(yF(:,ii),d,z,myd1_z0x(:,ii),myd0_z0x(:,ii),mz_x,md_z0x,1,weights);
            bs_lasft1(ii,:) = temp1;
        end
        if sum(isnan(bs_lasf0(:,1))) == 0
            bs_lqsf0 = interp1(bs_lasf0(:,1),percs,taus);
        else
            bs_lqsf0 = NaN*ones(numel(taus),1);
        end
        if sum(isnan(bs_lasf1(:,1))) == 0
            bs_lqsf1 = interp1(bs_lasf1(:,1),percs,taus);
        else
            bs_lqsf1 = NaN*ones(numel(taus),1);
        end
        if sum(isnan(bs_lasft0(:,1))) == 0
            bs_lqsft0 = interp1(bs_lasft0(:,1),percs,taus);
        else
            bs_lqsft0 = NaN*ones(numel(taus),1);
        end
        if sum(isnan(bs_lasft1(:,1))) == 0
            bs_lqsft1 = interp1(bs_lasft1(:,1),percs,taus);
        else
            bs_lqsft1 = NaN*ones(numel(taus),1);
        end
        
        bs_lqte(jj,:) = bs_lqsf1 - bs_lqsf0 ;
        bs_lqtt(jj,:) = bs_lqsft1 - bs_lqsft0 ;

    end
 
%     bs_std_lqte = std(bs_lqte);
%     bs_std_lqtt = std(bs_lqtt);
    bs_std_lqte = iqr(bs_lqte)/(norminv(.75)-norminv(.25));
    bs_std_lqtt = iqr(bs_lqtt)/(norminv(.75)-norminv(.25));
    
    bs_t_lqte = abs(bs_lqte - ones(reps,1)*lqte)./(ones(reps,1)*bs_std_lqte) ;
    bs_tmax_lqte = max(bs_t_lqte,[],2);
    talpha_lqte = prctile(bs_tmax_lqte,(1-alpha)*100);
    
    bs_t_lqtt = abs(bs_lqtt - ones(reps,1)*lqtt)./(ones(reps,1)*bs_std_lqtt) ;
    bs_tmax_lqtt = max(bs_t_lqtt,[],2);
    talpha_lqtt = prctile(bs_tmax_lqtt,(1-alpha)*100);
    
    lqte = [lqte ; bs_std_lqte];
    lqtt = [lqtt ; bs_std_lqtt];
end
